/*
  ditoh@andrew.cmu.edu
  MTI Spring '18
  Assignment 4
*/

// serial
var serial;
var portName = '/dev/cu.usbmodem1421';
var sampleRate = {baudrate: 9600};

// bar global
var barHeight = -10;
var posHeight = 0;
var goalHeight = 0;
var barColor = 'gray';

// text message
var statusText = '(waiting)'

var currTime = 0;

function setup()
{
  // serial settings for p5js
  serial = new p5.SerialPort();
  serial.on('list', printList);
  serial.on('connected', serverConnected);
  serial.on('open', portOpen);
  serial.on('data', serialEvent);
  serial.on('error', serialError);
  serial.on('close', portClose);
  serial.open(portName, sampleRate);

  // set up our drawing environment
  createCanvas(windowWidth, windowHeight);
  goalHeight = windowHeight/2.5;
}

function draw()
{
  if (currTime > 0 && millis() - currTime > 700)
  {
    goalHeight = random(500, 250);
    barHeight = -10;
    currTime = 0;
    barColor = 'gray';
    statusText = '(waiting)'
  }

  background(255);
  noStroke();

  // text
  textSize(32);
  fill('black');
  text(statusText, windowWidth/1.55, windowHeight/2);
  // sensor value
  fill(barColor);
  rect(windowWidth/4.2, windowHeight/1.2, 200, barHeight);
  // ideal value
  fill('red');
  rect(windowWidth/4.2, goalHeight, 200, -10);
  // surrounding box
  stroke('black');
  fill('rgba(0%,0%,0%,0)');
  rect(windowWidth/7, windowHeight/1.2, 450, -530);
  // surrounding box
  fill('rgba(0%,0%,0%,0)');
  rect(windowWidth/1.9, windowHeight/1.2, 450, -530);
}

function serialEvent()
{
  dataRead = Number(serial.read());
  barHeight = map(dataRead, 0, 255, 50, 500) * -1;
  posHeight = windowHeight / 1.2 + barHeight;

  if (abs(posHeight - goalHeight) < 30)
  {
    statusText = 'Good Hit!';
    barColor = 'red';
  }
  else if (posHeight < goalHeight)
  {
    statusText = 'Too Strong';
    barColor = 'gray';
  }
  else {
    statusText = 'Too Weak';
    barColor = 'gray';
  }

  // set timer to move to change goal value
  currTime = millis();
}

function mousePressed()
{
  barHeight = random(10, 500) * -1;
  posHeight = windowHeight / 1.2 + barHeight;

  if (abs(posHeight - goalHeight) < 30)
  {
    statusText = 'Good Hit!';
    barColor = 'red';
  }
  else if (posHeight < goalHeight)
  {
    statusText = 'Too Strong';
    barColor = 'gray';
  }
  else {
    statusText = 'Too Weak';
    barColor = 'gray';
  }

  // set timer to move to change goal value
  currTime = millis();
}

//------------------------------------------------------------------------------

function printList(portList)
{
  for (var i = 0; i < portList.length; i++) {
    print(i + " " + portList[i]);
  }
}

function serverConnected()
{
  print('serverConnected');
}

function portOpen()
{
  print('portOpen');
}

function serialError(err)
{
  print('serialError ' + err);
}

function portClose()
{
  print('portClose');
}
